#include <iostream>
using namespace std;

struct elem
{
    int num;
    elem *next;
};

void add_element (elem*&first, elem*&last, int i)
{
    elem *p = new elem;
    p->num = i;
    p->next = NULL;
    if (first == NULL) first = p;
    else last->next = p;
    last = p;
};

void print_list (elem *first)
{
    for (elem *p = first; p!=NULL; p=p->next)
    {
        cout << p->num << endl;
    };
};

void delete_list (elem*&first)
{
    elem *p = first;
    while (p!=NULL)
    {
        first = first->next;
        delete p;
        p = first;
    };
};

elem *get_element_by_num (elem *first, int num)
{
     elem *p = first;
     while (p!=NULL && p->num!=num) p=p->next;
     return p;
};

void insert_after (elem*&first, elem*&last, elem *e, int num)
{
     elem *p = new elem;
     p->num = num;
     p->next = NULL;
     if (e == NULL)
     {
           if (first == NULL) first = last = p;
           else
           {
               p->next = first;
               first = p;
           }
     }
     else
     {
         p->next = e->next;
         e->next = p;
         if (e == last) last = p;
     }
};

int main ()
{
    elem *first=NULL, *last=NULL, *p;
    int i;
    cin >> i;
    while (i != 0)
    {
        add_element (first, last, i);
        cin >> i;
    };
    cout << "The list: " << endl;
    print_list (first);
    cout << "Input the value of an element: ";
    cin >> i;
    p = get_element_by_num (first, i);
    if (p == NULL) cout << "No such element: " << i << endl;
    else
    {
        cout << "The list, starting with the element: " << i << endl;
        print_list (p);
    };
    cout << "Input the value of an element to insert after the previously named one: ";
    cin >> i;
    insert_after (first, last, p, i);
    cout << "The new list: " << endl;
    print_list (first);
    delete_list (first);
    return 0;
}
